(function() {
  var React, T, code, cx, div, hljs, pre;

  cx = require('classnames');

  hljs = require('highlight.js/lib/highlight');

  React = require('react');

  code = React.createFactory('code');

  div = React.createFactory('div');

  pre = React.createFactory('pre');

  T = React.PropTypes;

  module.exports = React.createClass({
    displayName: 'lite-code-viewer',
    propTypes: {
      codeType: T.string,
      name: T.string,
      text: T.string
    },
    getDefaultProps: function() {
      return {
        codeType: 'nohighlight',
        text: ''
      };
    },
    componentDidMount: function() {
      return this.highlightCode();
    },
    componentDidUpdate: function() {
      return this.highlightCode();
    },
    highlightCode: function() {
      var codes, viewer;
      if (this.props.codeType === 'nohighlight') {
        return;
      }
      viewer = this.refs.viewer.getDOMNode();
      codes = viewer.querySelectorAll('pre code');
      if (codes != null ? codes.length : void 0) {
        return [].forEach.call(codes, function(code) {
          return hljs.highlightBlock(code);
        });
      }
    },
    render: function() {
      var className, obj;
      className = cx((
        obj = {
          'lite-code-viewer': true
        },
        obj["is-for-" + this.props.name] = this.props.name != null,
        obj
      ));
      return div({
        className: className,
        ref: 'viewer'
      }, pre(null, code({
        className: this.props.codeType
      }, this.props.text)));
    }
  });

}).call(this);
